//+------------------------------------------------------------------+
//|                                                   test_ind_1.mq4 |
//|                                       Copyright  2010, Alex Mel |
//|                                                      wgann@bk.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Alex Mel"
#property link      "wgann@bk.ru"
#property indicator_chart_window

#import "testdll1.dll"
   bool fnLoadLibrary();
   int fnCalculateShortSwings(double rates[][6],int,double ShortTerm[][3],int);
#import

//   
double ShortTermBuf[],ShortTerm[2][3];
//

bool first_time;// ,          0

//      
int PaintShortSwings(int j)
{
   int arr_idx=0;
   while(j>=1)                      
   {
      if(j==ShortTerm[arr_idx][0])
      {
         ShortTermBuf[j]=ShortTerm[arr_idx][2];
         Print(DoubleToStr(ShortTerm[arr_idx][2],5));//  
         arr_idx++;
      }
      j--;
   }
   
   return;
}
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
      //   
      if(fnLoadLibrary())
         Print("The library testdll1.dll is successfully loaded");
      else
         Print("The library testdll1.dll is not loaded");
         
//---- indicators
      SetIndexBuffer(0,ShortTermBuf);         //   
      SetIndexStyle (0,DRAW_SECTION,STYLE_SOLID,2);//  
   
//----
      first_time=false;
//----
      return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i,total_short_swings,counted_bars;
   double rates[][6];
//----
   ArrayResize(ShortTerm,Bars);
   counted_bars=IndicatorCounted();
   ArrayCopyRates(rates);
   
   if(first_time)
   {
      i=Bars-counted_bars;
      total_short_swings=fnCalculateShortSwings(rates,Bars,ShortTerm,i);// -  
      if(total_short_swings>0)
      {          
         Print("total_short_swings ",total_short_swings);
         Print("ShortTerm[0][2] ",DoubleToStr(ShortTerm[0][2],5));
         PaintShortSwings(i);
      }
   }
   else if(!first_time)
   {
      i=Bars-counted_bars-1; 
      total_short_swings=fnCalculateShortSwings(rates,Bars,ShortTerm,i);
      if(total_short_swings>0)
      {
         Print("total_short_swings ",total_short_swings);
         Print("ShortTerm[0][0] ",ShortTerm[0][0]);
         Print("ShortTerm[0][1] ",ShortTerm[0][1]);
         Print("ShortTerm[0][2] ",DoubleToStr(ShortTerm[0][2],5));
         PaintShortSwings(i);
         first_time=true;
      }
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+


